local s1, s2, s3, sq

local playing, finishing, wasplaying

function love.load()
  s1 = love.sound.newSoundData('motor_start.wav')
  s2 = love.sound.newSoundData('motor_loop.wav')
  s3 = love.sound.newSoundData('motor_stop.wav')
  sq = love.audio.newQueueableSource(44100, 16, 1, 2)
end

function love.update(dt)
  if playing then
    if finishing then
      if sq:getFreeBufferCount() > 0 then
        sq:queue(s3)
        playing = false
      end
    elseif not wasplaying then
      sq:queue(s1)
      sq:play()
    else
      sq:queue(s2)
    end
  end
  wasplaying = playing
end

function love.keypressed(k)
  if k == "space" or k == " " then
    playing = true
    finishing = false
  end
  if k == "escape" then love.event.quit() end
end

function love.keyreleased(k)
  if k == "space" or k == " " then
    finishing = true
  end
end

function love.draw()
  love.graphics.print("Press 'space' to start; release it to stop")
end
